

#include <allegro.h>
#include <iostream>
#include "BasicAllegroSetup.hpp"

using std::endl;

bool get_allegro_ready(bool use_keyboard , bool use_timer , bool use_mouse , ofstream &text_log) {
  
  bool use_log = true;
  if (!text_log) {use_log = false;}
  
  if (allegro_init() != 0) {
    if (use_log) {
      text_log << "### Allegro initialization failed. Allegro reports : " << allegro_error << endl;
    }
    return false;
  } else {
    if (use_log) {
      text_log << "$$$ Allegro initialization successful." << endl;
    }
  }
  if (use_keyboard) {
    if (install_keyboard() != 0) {
      if (use_log) {
        text_log << "### Allegro keyboard initialization failed. Allegro reports : " << allegro_error << endl;
      }
      return false;
    } else {
      if (use_log) {
        text_log << "$$$ Allegro keyboard initialization successful." << endl;
      }
    }
  }
  if (use_timer) {
    if (install_timer() != 0) {
      if (use_log) {
        text_log << "### Allegro timer initialization failed. Allegro reports : " << allegro_error << endl;
      }
      return false;
    } else {
      if (use_log) {
        text_log << "$$$ Allegro timer initialization successful." << endl;
      }
    }
  }
  int num_mouse_buttons = 0;
  if (use_mouse) {
    num_mouse_buttons = install_mouse();
    if (install_mouse() == -1) {
      if (use_log) {
        text_log << "### Allegro mouse initialization failed. Allegro reports : " << allegro_error << endl;
      }
      return false;
    } else {
      if (use_log) {
        text_log << "$$$ Allegro mouse initialization successful. The mouse in use has " << num_mouse_buttons << " buttons." << endl;
      }
    }
  }
  return true;
}



