
#include "Edges.hpp"

#include <cmath>


/// KEdge class member functions
Edge::Edge() {
  KWeight = 0;
  checked = false;
  on = false;
  vpt1 = NULL;
  vpt2 = NULL;
}

Edge::~Edge() {}

void Edge::SetEdgeStatus(bool turn_on) {
  on = turn_on;
  checked = true;
}

void Edge::Draw(BITMAP* bmp , const int& on_color , const int& off_color , bool draw_off_edges) {
  if (!on) {
    if (!draw_off_edges) {return;}
  }
  if (on) {
    line(bmp , vpt1->x , vpt1->y , vpt2->x , vpt2->y , on_color);
  } else {
    line(bmp , vpt1->x , vpt1->y , vpt2->x , vpt2->y , off_color);
  }
}

void Edge::IsoMetricDraw(const double& z_angle_rad , BITMAP* bmp , const int& on_color , const int& off_color , bool draw_off_edges) {
  if (!on) {
    if (!draw_off_edges) {return;}
  }
  const double sine_zangle = sin(z_angle_rad);
  const double cos_zangle = cos(z_angle_rad);
  int p1_x_offset = static_cast<int>(static_cast<double>(vpt1->z)*cos_zangle);
  int p1_y_offset = static_cast<int>(static_cast<double>(vpt1->z)*sine_zangle);
  int p2_x_offset = static_cast<int>(static_cast<double>(vpt2->z)*cos_zangle);
  int p2_y_offset = static_cast<int>(static_cast<double>(vpt2->z)*sine_zangle);
  if (on) {
    line(bmp , p1_x_offset + vpt1->x , p1_y_offset + vpt1->y , p2_x_offset + vpt2->x , p2_y_offset + vpt2->y , on_color);
  } else {
    line(bmp , p1_x_offset + vpt1->x , p1_y_offset + vpt1->y , p2_x_offset + vpt2->x , p2_y_offset + vpt2->y , off_color);
  }
}

/// #####################   End KEdge class member functions   ###############################


