
#include <iostream>
#include <fstream>
//#include <cmath>
#include <sstream>

#include <allegro.h>

#include "BasicAllegroSetup.hpp"
#include "KMaze.hpp"
#include "Shuffle.hpp"
#include "Player.hpp"
#include "Camera2.hpp"
//#include "MultiLineAllegroText.hpp"
//#include "HtmlTable.hpp"

using std::ofstream;
using std::endl;
using std::stringstream;

ofstream log_file(".\\KMaze_log.txt");

int maze_menu();
int max(int a , int b) {if (a >= b) {return a;} else {return b;}};

void draw_vm1(BITMAP* buf , const char* vm1[3] , int color);
void draw_vm2(BITMAP* buf , const char* vm2[3] , int color);
void draw_vm3(BITMAP* buf , const char* vm3[2] , int color);


int main() {
  
  /// Notes
  //     Need a zoom function for hard maze , different colors for maze walls , different way to represent player
  //     Add a minotaur! - it can hear sounds , will follow player if it can see it
  //     
  //     Add Sound features - maze music , footstep sounds that echo , 
  //     
  //     Item pickups?
  //     
  //     
  //     
  //     Code breaker game?
  //     
  if (!log_file) {return 0;}
  
//  const char* multilinetext = "Line 1\nLine 2\nThe Fourth Line Should Show Up\nThe Fourth Line Is Here!";
  
///  HtmlTable htmltable;
///  log_file << htmltable.dtd << endl;
/*
  // testing the post increment operator
  int var = 7;
  if (var == var++) {
    log_file << "(var == var++) returns true" << endl;
  } else {
    log_file << "(var == var++) returns false" << endl;
  }
  int var_copy = var;
  if (var_copy == var++) {
    log_file << "(var_copy == var++) returns true" << endl;
  } else {
    log_file << "(var_copy == var++) returns false" << endl;
  }
*/
  
  if (!get_allegro_ready(true , true , true , log_file)) {return 0;}
  
  set_color_depth(32);
//  if (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN , 1024 , 768 , 0 , 0) != 0) {
  if (set_gfx_mode(GFX_AUTODETECT_WINDOWED , 800 , 600 , 0 , 0) != 0) {
//  if (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN , 800 , 600 , 0 , 0) != 0) {
    log_file << "Failed to set 32 bit 800 X 600 GFX_AUTODETECT_WINDOWED mode" << endl;
//    log_file << "Failed to set 32 bit 800 X 600 GFX_AUTODETECT_FULLSCREEN mode" << endl;
    if (set_gfx_mode(GFX_TEXT , 0 , 0 , 0 , 0) == 0) {
      allegro_message(allegro_error);
    }
    return 0;
  }
  
  if (set_display_switch_mode(SWITCH_BACKGROUND) != 0) {
    log_file << "### Could not set SWITCH_BACKGROUND display switching mode" << endl;
    if (set_display_switch_mode(SWITCH_BACKAMNESIA) != 0) {
      log_file << "### Could not set SWITCH_BACKAMNESIA display switching mode" << endl;
    } else {
      log_file << "$$$ SWITCH_BACKAMNESIA display switching mode has been set" << endl;
    }
  } else {
    log_file << "$$$ SWITCH_BACKGROUND display switching mode has been set" << endl;
  }
  
  BITMAP* buf = create_bitmap(800,600);
  if (!buf) {return 0;}
  clear_to_color(buf , makecol(0,0,0));
  
  BITMAP* v_buf = create_bitmap(800,600);
  if (!v_buf) {return 0;}
  clear_to_color(v_buf , makecol(0,0,0));
  
  stringstream easy_output;
  
/*
  while (!(key[KEY_ESC])) {
    easy_output.str("");
    
    easy_output << "Option " << maze_menu() << " chosen";
    clear_to_color(screen , makecol(0,0,0));
    
    textout_centre_ex(screen , font , (easy_output.str()).c_str() , SCREEN_W / 2 , SCREEN_H / 2 , makecol(0,255,0) , -1);
    clear_keybuf();
    readkey();
  }
*/
/*
//  if (!(maze.InitializeGrid(60 , 45 , 100 , 75 , 25 , 10 , 10))) {// 600 X 450
///  if (!(maze.InitializeGrid(48 , 36 , 112 , 84 , 0 ,  12 , 12))) {
///  if (!(maze.InitializeGrid(64 , 48 , 64 , 48 , 25 ,  14 , 14))) {// 1024 - 128 X 768 - 96 = 896 X 672
//  if (!(maze.InitializeGrid(24 , 18 , 100 , 75 , 25 , 25))) {
//  if (!(maze.InitializeGrid(24 , 18 , 100 , 75 , 25 , 25 , 25))) {// 600 X 450
//  if (!(maze.InitializeGrid(60 , 45 , 100 , 75 , 25 , 10 , 10))) {// 600 X 450
  if (!(maze.InitializeGrid(32 , 24 , 80 , 60 , 25 , 20 , 20))) {// 640 X 480 , 32 X 24
//  if (!(maze.InitializeGrid(32 , 24 , 64 , 48 , 25 , 28 , 28))) {// 896 X 672
//  if (!(maze.InitializeGrid(12 , 9 , 100 , 75 , 50 , 50))) {// 600 X 450 , 12 X 9
//  if (!(maze.InitializeGrid(4 , 3 , 100 , 75 , 150 , 150))) {
*/

//  if (!(maze.InitializeGrid(12 , 9 , 100 , 75 , 25 , 50 , 50))) {// 600 X 450 , 12 X 9
//  if (!(maze.InitializeGrid(32 , 24 , 80 , 60 , 25 , 20 , 20))) {// 640 X 480 , 32 X 24
//  if (!(maze.InitializeGrid(60 , 45 , 100 , 75 , 25 , 10 , 10))) {// 600 X 450 , 60 X 45

//  const char vm1[] = "Congratulations , you beat the Easy maze , now try Medium!";
  
  const char vm1a[] = "Congratulations , you";
  const char vm1b[] = "beat the Easy maze!";
  const char vm1c[] = "Now try Medium!";
  
//  const char vm2[] = "Good job! Do you think you can beat the Hard maze?";
  
  const char vm2a[] = "Good job! Do you ";
  const char vm2b[] = "think you can beat";
  const char vm2c[] = "the Hard maze?";
  
//  const char vm3[] = "Awesome! No way! Can you do it again?";
  
  const char vm3a[] = " Awesome!   No way! ";
  const char vm3b[] = "Can you do it again?";
  
//  const char* victory_messages[3] = {vm1 , vm2 , vm3};
  
  const char* victory_message1[3] = {vm1a , vm1b , vm1c};
  const char* victory_message2[3] = {vm2a , vm2b , vm2c};
  const char* victory_message3[2] = {vm3a , vm3b};

  const int vm1w = max(text_length(font , vm1a) , max(text_length(font , vm1b) , text_length(font , vm1c))) + 8;
  const int vm1h = 3*(text_height(font) + 4) + 8;
  const int vm2w = max(text_length(font , vm2a) , max(text_length(font , vm2b) , text_length(font , vm2c))) + 8;
  const int vm2h = 3*(text_height(font) + 4) + 8;
  const int vm3w = max(text_length(font , vm3a) , text_length(font , vm3b)) + 8;
  const int vm3h = 2*(text_height(font) + 4) + 8;
  
  BITMAP* vm_bmp1 = create_bitmap(vm1w , vm1h);
  BITMAP* vm_bmp2 = create_bitmap(vm2w , vm2h);
  BITMAP* vm_bmp3 = create_bitmap(vm3w , vm3h);

//  BITMAP* vm_bmp1 = create_bitmap(text_length(font , vm1) , text_height(font));
//  BITMAP* vm_bmp2 = create_bitmap(text_length(font , vm2) , text_height(font));
//  BITMAP* vm_bmp3 = create_bitmap(text_length(font , vm3) , text_height(font));
  if (!vm_bmp1) {return 0;}
  if (!vm_bmp2) {return 0;}
  if (!vm_bmp3) {return 0;}
  BITMAP* const vm_bitmaps[3] = {vm_bmp1 , vm_bmp2 , vm_bmp3};
  BITMAP* vm_bmp = NULL;

  int r, g, b;
  float h, s, v;
  float ah = 0.0;
  r = g = b = 0;
  h = 60.0;
  s = 1.0;
  v = 1.0;
  hsv_to_rgb(h,s,v,&r,&g,&b);

//  for (int i = 0 ; i < 3 ; i++) {
//    clear_to_color(vm_bitmaps[i] , makecol(255,0,255));// for transparency
//    textout_ex(vm_bitmaps[i] , font , victory_messages[i] , 0 , 0 , makecol(r,g,b) , -1);
//  }
  int i = 0;
  clear_to_color(vm_bitmaps[i] , makecol(255,0,255));// for transparency
  textout_ex(vm_bitmaps[i] , font , victory_message1[0] , 0 , 2 , makecol(r,g,b) , -1);
  textout_ex(vm_bitmaps[i] , font , victory_message1[1] , 0 , 14 , makecol(r,g,b) , -1);
  textout_ex(vm_bitmaps[i] , font , victory_message1[2] , 0 , 26 , makecol(r,g,b) , -1);
  
  i = 1;
  clear_to_color(vm_bitmaps[i] , makecol(255,0,255));// for transparency
  textout_ex(vm_bitmaps[i] , font , victory_message2[0] , 0 , 2 , makecol(r,g,b) , -1);
  textout_ex(vm_bitmaps[i] , font , victory_message2[1] , 0 , 14 , makecol(r,g,b) , -1);
  textout_ex(vm_bitmaps[i] , font , victory_message2[2] , 0 , 26 , makecol(r,g,b) , -1);

  i = 2;
  clear_to_color(vm_bitmaps[i] , makecol(255,0,255));// for transparency
  textout_ex(vm_bitmaps[i] , font , victory_message3[0] , 0 , 2 , makecol(r,g,b) , -1);
  textout_ex(vm_bitmaps[i] , font , victory_message3[1] , 0 , 14 , makecol(r,g,b) , -1);

  const char* difficulty[3] = {"Easy" , "Medium" , "Hard"};
  KMaze easy , medium , hard;
  KMaze* mazes[3] = {&easy , &medium , &hard};
  
  KMaze* maze_ptr = NULL;
  
  Player player;
  Player old_player;
  
  if (!(easy.InitializeGrid(12 , 9 , 100 , 75 , 25 , 50 , 50))) {// 600 X 450 , 12 X 9
    log_file << "Easy Maze Initialization failed" << endl;
    return 0;
  }
  if (!(medium.InitializeGrid(32 , 24 , 80 , 60 , 25 , 20 , 20))) {// 640 X 480 , 32 X 24
    log_file << "Normal Maze Initialization failed" << endl;
    return 0;
  }
  if (!(hard.InitializeGrid(60 , 45 , 100 , 75 , 25 , 10 , 10))) {// 600 X 450 , 60 X 45
    log_file << "Hard Maze Initialization failed" << endl;
    return 0;
  }
  int option = 0;
  int old_option = 0;
  bool start = true;
  bool skip_message = false;
  
  for (i = 0 ; i < 3 ; i++) {
    mazes[i]->ResetGridEdges();
  }
  
  Camera buffer_copy_cam(buf , v_buf);
//  buffer_copy_cam.SetLogFile(&log_file);
  
//  Camera buffer_cam(buf , v_buf);
  Camera buffer_cam(buf , screen);
//  buffer_cam.SetLogFile(&log_file);
  buffer_cam.Set_Zoom_Rate_Hundredths(5);
//  buffer_cam.Set_Output_Rectangle(400 , 799 , 300 , 599);
  
  Camera v_buf_cam(v_buf , screen);
//  v_buf_cam.SetLogFile(&log_file);
  
  int m_pos = 0;
  int m_x = 0;
  int m_y = 0;
  int last_m_z = 0;
  int m_z = 0;
  int m_z_change = 0;
  int m_w = 0;
  int last_m_w = 0;
  int m_w_change = 0;
  
  int x = 0;
  int y = 0;
  bool player_moved = true;// so player will be drawn initially
  
  while (1) {
    
    show_mouse(NULL);
    clear_to_color(screen , makecol(0,0,0));
    old_option = option;
    option = maze_menu();
    if (option == 4) {break;}
    
    if (!start) {
      mazes[old_option - 1]->ResetGridEdges();
    }
    
    if (start) {
      start = false;
    }
    
//    for (int i = 0 ; i < 3 ; i++) {
//      mazes[i]->ResetGridEdges();
//    }
    maze_ptr = mazes[option - 1];
    player.set_maze(maze_ptr , 1 , 1 , maze_ptr->sg_width / 2 , maze_ptr->sg_height / 2);
    
    maze_ptr->SetMazeBorderOn();
    maze_ptr->SetExit(maze_ptr->width , maze_ptr->height , "right");
    
    
    clear_to_color(buf , makecol(0,0,0));
    easy_output.str("");
    easy_output << "Building the " << difficulty[option - 1] << " difficulty maze , please wait";
    textout_centre_ex(buf , font , (easy_output.str()).c_str() , SCREEN_W/2 , SCREEN_H / 2 , makecol(0,255,255) , -1);
    
//    maze_ptr->KruskalizeGridEdges(log_file , buf , false);
    maze_ptr->KruskalizeGridEdgesByVTrees(log_file , buf , true);
    easy_output.str("");
    easy_output << "The " << difficulty[option - 1] << " maze is complete , press any key to begin!";
    textout_centre_ex(buf , font , (easy_output.str()).c_str() , SCREEN_W/2 , (SCREEN_H / 2) + 24 , makecol(0,255,0) , -1);
    blit(buf , screen , 0 , 0 , 0 , 0 , buf->w , buf->h);
    clear_keybuf();
    readkey();
    
    clear_to_color(buf , makecol(0,0,0));
    
    maze_ptr->DrawAllEdges(buf , makecol(255,255,255) , makecol(0,0,0) , false);
    textout_centre_ex(buf , font , "Make your way out of the maze!" , buf->w / 2 , 30 , makecol(255,255,255) , makecol(0,0,0));
    textout_centre_ex(buf , font , "Press ESC for the menu" , buf->w / 2 , 42 , makecol(255,255,255) , makecol(0,0,0));
    
    show_mouse(screen);
//    buf_cam.SetZoom(1);
    buffer_cam.Set_Zoom_Hundredths(100);
    
    player.draw(buf , makecol(0,255,0));
    
    while (!key[KEY_ESC]) {
      
      if (player_moved) {
        old_player = player;
      }
      if (player.move()) {
        old_player.draw(buf , makecol(0,0,0));// erase last position
        player.draw(buf , makecol(0,255,0));// draw new position
        buffer_cam.Set_Zoom_Center( (player.x + player.wd / 2) , (player.y + player.ht / 2));
//        log_file << "After Moving Player and recentering , Buffer Cam is : " << buffer_cam << endl;
        player_moved = true;
      } else {
        player_moved = false;
      }
      
      if (player.OutOfMaze()) {
        // made it out of the maze!
        player.draw(buf , makecol(0,255,0));
        vm_bmp = vm_bitmaps[option - 1];
        
        skip_message = false;
        for (int hue = 0 ; hue < 360 ; hue++) {
          ah = static_cast<float>(hue) + h;
          if (ah >= 360.0) {ah -= 360.0;}
          hsv_to_rgb(ah,s,v,&r,&g,&b);
          
          switch (option) {
            case 1 :
              draw_vm1(vm_bmp , victory_message1 , makecol(r,g,b));
              break;
            case 2 :
              draw_vm2(vm_bmp , victory_message2 , makecol(r,g,b));
              break;
            case 3 :
              draw_vm3(vm_bmp , victory_message3 , makecol(r,g,b));
              break;
          }
          
          blit(buf , v_buf , 0 , 0 , 0 , 0 , buf->w , buf->h);
  //void masked_stretch_blit(BITMAP *source, BITMAP *dest, int source_x, source_y, source_w, source_h, int dest_x, dest_y, dest_w, dest_h);
//          masked_stretch_blit(vm_bmp , v_buf , 0 , 0 , vm_bmp->w , vm_bmp->h , (v_buf->w - vm_bmp->w) / 2 , (v_buf->h - vm_bmp->h) / 2 , vm_bmp->w , vm_bmp->h);
          masked_stretch_blit(vm_bmp , v_buf , 0 , 0 , vm_bmp->w , vm_bmp->h , (v_buf->w / 2) - vm_bmp->w , (v_buf->h / 2) - vm_bmp->h , 2*(vm_bmp->w) , 2*(vm_bmp->h));
          stretch_blit(vm_bmp , v_buf , 0 , 0 , vm_bmp->w , vm_bmp->h , (v_buf->w / 2) - vm_bmp->w , (v_buf->h / 2) - vm_bmp->h , 2*(vm_bmp->w) , 2*(vm_bmp->h));
          blit(v_buf , screen , 0 , 0 , 0 , 0 , v_buf->w , v_buf->h);
          if (keypressed()) {
            break;
//            rest(0);
//            hue = 360;
//            skip_message = true;
          } else {
            rest(25);
          }
        }
        
//        if (!skip_message) {
//          clear_keybuf();
//          readkey();
          rest(250);
          clear_keybuf();
//          readkey();
//        }
        break;
      }
      
      
      last_m_z = m_z;
      m_z = mouse_z;
      m_z_change = m_z - last_m_z;
      
      last_m_w = m_w;
      m_w = mouse_w;
      m_w_change = m_w - last_m_w;
      
      /// adjust scale with vertical mouse wheel
      if (m_z_change != 0) {
        buffer_cam.Alter_Zoom(25*m_z_change);
//        log_file << "After Altering Zoom , Buffer Cam is : " << buffer_cam << endl;
      }
      /// adjust scale with vertical mouse wheel
      if (m_w_change != 0) {
        buffer_cam.Alter_Zoom(5*m_w_change);
//        log_file << "After Altering Zoom , Buffer Cam is : " << buffer_cam << endl;
      }
      
      if (mouse_b & 1) {
//    bool Map_Output_Coord_to_View_Coord(int op_x , int op_y , int* v_x , int* v_y) {
        m_pos = mouse_pos;
        m_x = m_pos >> 16;
        m_y = m_pos & 0x0000ffff;
//        if (buffer_cam.Map_Output_Coord_to_View_Coord(m_x , m_y , &m_x , &m_y)) {
//        if (buffer_cam.Map_Output_Coord_to_View_Coord(399 + (m_x-399)/4 , 299 + (m_y-299)/4 , &m_x , &m_y)) {
//          buffer_cam.Set_Zoom_Center( m_x , m_y );
//        }
        x = (m_x - 399) / 25;
        y = (m_y - 299) / 25;
        buffer_cam.Scroll_Zoom_Center(x , y);
        
        
        buffer_cam.Zoom_Out();
//        log_file << "After Zooming Out , Buffer Camera is : " << buffer_cam << endl;
/*
        log_file << "Tlx = " << buffer_cam.v_zoom_tlx << " , Tly = " << buffer_cam.v_zoom_tly << " after zooming out";
//        log_file << " Wid = " << buffer_cam.v_zoom_wid << " , Ht = " << buffer_cam.v_zoom_ht << endl;
        log_file << "Brx = " << buffer_cam.v_zoom_brx << " , Bry = " << buffer_cam.v_zoom_bry << " after zooming out" << endl;
//        log_file << " , x distance from v_zoom_tlx to player's left edge is : " << (player.x - buffer_cam.v_zoom_tlx);
//        log_file << " , y distance from v_zoom_tly to player's top edge is : " << (player.y - buffer_cam.v_zoom_tly) << endl;
        log_file << "Player's position : Relative to display : " << (player.x - buffer_cam.v_zoom_tlx) << " , " << (player.y - buffer_cam.v_zoom_tly);
        log_file << " Absolute position : " << player.x << " , " << player.y << endl;
*/
//        rest(100);
      }
      if (mouse_b & 2) {
        m_pos = mouse_pos;
        m_x = m_pos >> 16;
        m_y = m_pos & 0x0000ffff;
//        if (buffer_cam.Map_Output_Coord_to_View_Coord(m_x , m_y , &m_x , &m_y)) {
//        if (buffer_cam.Map_Output_Coord_to_View_Coord(m_x , m_y , &m_x , &m_y)) {
//        if (buffer_cam.Map_Output_Coord_to_View_Coord(399 + (m_x-399)/4 , 299 + (m_y-299)/4 , &m_x , &m_y)) {
//          buffer_cam.Set_Zoom_Center( m_x , m_y );
//        }
        x = (m_x - 399) / 25;
        y = (m_y - 299) / 25;
        buffer_cam.Scroll_Zoom_Center(x , y);
        
        buffer_cam.Zoom_In();
//        log_file << "After Zooming In , Buffer Camera is : " << buffer_cam << endl;
/*
        log_file << "Tlx = " << buffer_cam.v_zoom_tlx << " , Tly = " << buffer_cam.v_zoom_tly << " after zooming out";
//        log_file << " Wid = " << buffer_cam.v_zoom_wid << " , Ht = " << buffer_cam.v_zoom_ht << endl;
        log_file << "Brx = " << buffer_cam.v_zoom_brx << " , Bry = " << buffer_cam.v_zoom_bry << " after zooming out" << endl;
//        log_file << " , x distance from v_zoom_tlx to player's left edge is : " << (player.x - buffer_cam.v_zoom_tlx);
//        log_file << " , y distance from v_zoom_tly to player's top edge is : " << (player.y - buffer_cam.v_zoom_tly) << endl;
        log_file << "Player's position : Relative to display : " << (player.x - buffer_cam.v_zoom_tlx) << " , " << (player.y - buffer_cam.v_zoom_tly);
        log_file << " Absolute position : " << player.x << " , " << player.y << endl;
*/
//        rest(100);
      }
      
//      buffer_copy_cam.Display();
      buffer_cam.Display();
//void multiline_textout_v1a(BITMAP* bmp , FONT *font , const char *ml_str , int x , int y , int v_spacing , int fg , int bg ,
//                              void (*text_func) (BITMAP* , const FONT* , const char* , int , int , int , int)) {
//      multiline_textout_v1a(screen , font , "multilinetext" , 400 , 540 , 12 , makecol(0,255,255) , -1 , textout_right_ex);
///      multiline_textout_v1a(screen , font , multilinetext , 400 , 540 , 12 , makecol(0,255,255) , -1 , textout_right_ex);
//      v_buf_cam.Display();
//      blit(buf , screen , 0 , 0 , 0 , 0 , buf->w , buf->h);
      
      rest(25);
    }
    
  }
  
  destroy_bitmap(buf);
  destroy_bitmap(v_buf);
  destroy_bitmap(vm_bmp1);
  destroy_bitmap(vm_bmp2);
  destroy_bitmap(vm_bmp3);
  easy.DestroyGrid();
  medium.DestroyGrid();
  hard.DestroyGrid();
  return 0;
}
END_OF_MAIN()


void draw_vm1(BITMAP* buf , const char* vm1[3] , int color) {
//  clear_to_color(buf , makecol(255,0,255));// for transparency
  clear_to_color(buf , makecol(0,0,0));// black background
  rect(buf , 0 , 0 , buf->w - 1 , buf->h - 1 , makecol(0,255,0));
  rect(buf , 1 , 1 , buf->w - 2 , buf->h - 2 , makecol(0,255,0));
  
//  textout_ex(buf , font , vm1[0] , 0 , 2 , color , -1);
//  textout_ex(buf , font , vm1[1] , 0 , 14 , color , -1);
//  textout_ex(buf , font , vm1[2] , 0 , 26 , color , -1);
  textout_ex(buf , font , vm1[0] , 4 , 6 , color , -1);
  textout_ex(buf , font , vm1[1] , 4 , 18 , color , -1);
  textout_ex(buf , font , vm1[2] , 4 , 30 , color , -1);
}
void draw_vm2(BITMAP* buf , const char* vm2[3] , int color) {
//  clear_to_color(buf , makecol(255,0,255));// for transparency
  clear_to_color(buf , makecol(0,0,0));// black background
  rect(buf , 0 , 0 , buf->w - 1 , buf->h - 1 , makecol(0,255,0));
  rect(buf , 1 , 1 , buf->w - 2 , buf->h - 2 , makecol(0,255,0));
  
  textout_ex(buf , font , vm2[0] , 4 , 6 , color , -1);
  textout_ex(buf , font , vm2[1] , 4 , 18 , color , -1);
  textout_ex(buf , font , vm2[2] , 4 , 30 , color , -1);
}
void draw_vm3(BITMAP* buf , const char* vm3[2] , int color) {
//  clear_to_color(buf , makecol(255,0,255));// for transparency
  clear_to_color(buf , makecol(0,0,0));// black background
  rect(buf , 0 , 0 , buf->w - 1 , buf->h - 1 , makecol(0,255,0));
  rect(buf , 1 , 1 , buf->w - 2 , buf->h - 2 , makecol(0,255,0));
  
  textout_ex(buf , font , vm3[0] , 4 , 6 , color , -1);
  textout_ex(buf , font , vm3[1] , 4 , 18 , color , -1);
}

int maze_menu() {
  
  clear_to_color(screen , makecol(0,0,0));
  
  const char title[]     = "Press 1-4 to continue";
  const char underline[] = "-----------------------";
  const char option1[]   = "1. Play easy maze";
  const char option2[]   = "2. Play normal maze";
  const char option3[]   = "3. Play difficult maze";
  const char option4[]   = "4. Exit game";
  
  show_mouse(NULL);
  
  const int average_length = (text_length(font , title) + text_length(font , underline) + 
                                text_length(font , option1) + text_length(font , option2) + 
                                 text_length(font , option3) + text_length(font , option4)) / 6;
  
  const char* text[] = {title , underline , option1 , option2 , option3 , option4};
  const int xpos = (SCREEN_W - average_length) / 2;
  const int line_spacing = 12;
  const int ypos = (SCREEN_H / 2) - 3*line_spacing;
  
  for (int i = 0 ; i < 6 ; i++) {
    textout_ex(screen , font , text[i] , xpos , ypos + 2 + i*line_spacing , makecol(255,255,255) , -1);
  }
  
  const int userkeys[] = {KEY_1 , KEY_2 , KEY_3 , KEY_4};
  int option_number = 0;
  
  bool option_chosen = false;
  
  while(!option_chosen) {
    
    for (int i = 0 ; i < 4 ; i++) {
      if (key[userkeys[i]]) {
        option_number = i + 1;
        rest(150);
        option_chosen = true;
      }
    }
    
    rest(25);
  }
  
  return option_number;
}


/*
int main() {
  
  if (!log_file) {return 0;}
  
  /// Test the MakeRandomizedArrayCopy function
//template <class Any>
//Any* MakeRandomizedArrayCopy (Any* const ArrayToShuffle , const int& num_elements , const int& num_shuffles , ofstream& log_file) {

  int OneToTen[10] = {1,2,3,4,5,6,7,8,9,10};
  
  log_file << endl;
  log_file << "One To Ten Array Contents : " << endl;
  for (int i = 0 ; i < 10 ; i++) {
    log_file << OneToTen[i] << " ";
  }
  log_file << endl;
  
  int *ShuffledOneToTen = MakeRandomizedArrayCopy(OneToTen , 10 , 3 , log_file);
  if (ShuffledOneToTen == NULL) {
    log_file << "Failed to allocate memory for the Shuffled One To Ten array" << endl;
    return 0;
  }
  
  log_file << endl;
  log_file << "Shuffled Copy of One To Ten Array Contents : " << endl;
  for (int i = 0 ; i < 10 ; i++) {
    log_file << ShuffledOneToTen[i] << " ";
  }
  log_file << endl;
  log_file << endl;
  
  delete [] ShuffledOneToTen;

  
//bool get_allegro_ready(bool use_keyboard , bool use_timer , bool use_mouse , ofstream &text_log);
  if (!get_allegro_ready(true , true , true , log_file)) {return 0;}
  
  set_color_depth(32);
//  if (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN , 1024 , 768 , 0 , 0) != 0) {
  if (set_gfx_mode(GFX_AUTODETECT_WINDOWED , 800 , 600 , 0 , 0) != 0) {
    log_file << "Failed to set 32 bit 800 X 600 GFX_AUTODETECT_WINDOWED mode" << endl;
    if (set_gfx_mode(GFX_TEXT , 0 , 0 , 0 , 0) == 0) {
      allegro_message(allegro_error);
    }
    return 0;
  }
  
  set_display_switch_mode(SWITCH_BACKGROUND);
  
  BITMAP* buf = create_bitmap(800,600);
  if (!buf) {return 0;}
  
  clear_to_color(buf , makecol(0,0,0));
  
  KMaze maze;
  int x = 0;//counter
  int v_wid = 3;// vertice drawing width
  
//  if (!(maze.InitializeGrid(60 , 45 , 100 , 75 , 25 , 10 , 10))) {// 600 X 450
///  if (!(maze.InitializeGrid(48 , 36 , 112 , 84 , 0 ,  12 , 12))) {
///  if (!(maze.InitializeGrid(64 , 48 , 64 , 48 , 25 ,  14 , 14))) {// 1024 - 128 X 768 - 96 = 896 X 672
//  if (!(maze.InitializeGrid(24 , 18 , 100 , 75 , 25 , 25))) {
//  if (!(maze.InitializeGrid(24 , 18 , 100 , 75 , 25 , 25 , 25))) {// 600 X 450
//  if (!(maze.InitializeGrid(60 , 45 , 100 , 75 , 25 , 10 , 10))) {// 600 X 450
  if (!(maze.InitializeGrid(32 , 24 , 80 , 60 , 25 , 20 , 20))) {// 640 X 480
//  if (!(maze.InitializeGrid(32 , 24 , 64 , 48 , 25 , 28 , 28))) {// 896 X 672
//  if (!(maze.InitializeGrid(12 , 9 , 100 , 75 , 50 , 50))) {
//  if (!(maze.InitializeGrid(4 , 3 , 100 , 75 , 150 , 150))) {
    log_file << "Maze Initialization failed" << endl;
    return 0;
  }
  set_window_title("Kruskal Mazes");
  

  for (x = 0 ; x < maze.total_vertice_count ; x++) {
    maze.DrawVertice(x , buf , makecol(0,0,255) , 16);
    blit(buf , screen , 0 , 0 , 0 , 0 , buf->w , buf->h);
    if ((readkey() >> 8) == KEY_ESC) {
      x = maze.total_vertice_count;
      rest(100);
    }
  }
  
  clear_to_color(buf , makecol(0,0,0));

  show_mouse(screen);

  double ms_angle_rad = M_PI / -3.0;
  int m_pos = 0;
  int m_x = 0;
  int m_y = 0;
  bool redraw = true;
  
  while (!key[KEY_ESC]) {
    
    if (redraw) {
      clear_to_color(buf , makecol(0,0,0));
//    textout_ex(buf , font , "Press ESC to skip seeing the edges connected to by each vertice" , 10 , 20 , makecol(255,255,255) , -1);
//    textout_ex(buf , font , "Press any other key to move to next vertice" , 10 , 36 , makecol(255,255,255) , -1);
//    maze.DrawAllVertices(buf , makecol(0,0,255) , v_wid);
//    maze.IsoMetricDrawAllVertices(M_PI / -3.0 , buf , makecol(255,0,255) , v_wid);
      maze.IsoMetricDrawAllEdges(ms_angle_rad , buf , makecol(255,255,0) , makecol(0,255,255) , true);
//    maze.DrawVertice(x , buf , makecol(255,0,255) , v_wid);
//    maze.IsoMetricDrawVertice(ms_angle_rad , x , buf , makecol(255,0,255) , v_wid);
//    maze.DrawVerticeEdges(x , buf , makecol(0,0,255) , makecol(255,255,0) , true);
//    maze.IsoMetricDrawVerticeEdges(ms_angle_rad , x , buf , makecol(0,0,255) , makecol(255,255,0) , true);
      scare_mouse();
      blit(buf , screen , 0 , 0 , 0 , 0 , buf->w , buf->h);
      unscare_mouse();
    }
    if (mouse_b & 1) {
      m_pos = mouse_pos;
      m_x = m_pos >> 16;
      m_y = m_pos & 0x0000ffff;
      ms_angle_rad = atan2( (m_y - buf->h/2) , (m_x - buf->w / 2) );
      redraw = true;
    } else {
      redraw = false;
    }
    rest(10);
  }
  show_mouse(NULL);
  rest(200);
  clear_keybuf();
  
  clear_to_color(buf , makecol(0,0,0));

  maze.DrawAllVertices(buf , makecol(0,0,255) , v_wid);

  for (x = 0 ; x < maze.total_edge_count ; x++) {
    if ((x % 2) == 0) {
      maze.DrawEdge(x , buf , makecol(0,0,255) , makecol(255,0,0) , true);
    } else {
      maze.DrawEdge(x , buf , makecol(0,0,255) , makecol(0,255,0) , true);
    }
    blit(buf , screen , 0 , 0 , 0 , 0 , buf->w , buf->h);
    clear_keybuf();
    if ((readkey() >> 8) == KEY_ESC) {
      x = maze.total_edge_count;
      rest(200);
    }
  }
  
  clear_to_color(buf , makecol(0,0,0));
//  if (!(maze.SetMazeBorderOn(1 , 1 , "top" , maze.width , maze.height , "right"))) {
//  if (!(maze.SetMazeBorderOn(1 , 1 , "top" , 1 , 1 , "top"))) {
  if (!(maze.SetMazeBorderOn())) {
    textout_centre_ex(buf , font , "Failed to Set Maze Border On" , buf->w / 2 , 20 , makecol(255,0,0) , -1);
  }
  if (!(maze.SetExit(maze.width , maze.height , "right"))) {
    textout_centre_ex(buf , font , "Failed to Set Maze Exit" , buf->w / 2 , 32 , makecol(255,0,0) , -1);
  }
  
  Edge* KE = NULL;
  Vertice* V = NULL;
  V = &(maze.VerticeArray[25]);
  maze.GridCoordToEdgePtr(1,2,"top",&KE);
  
  bool display_loop_checking = true;
  

  loop_formed = maze.IsLoopFormed(V , KE , true , &loop_check_failure , buf , &display_loop_checking);
  
  maze.DrawVertice(25 , buf , makecol(255,0,255) , v_wid);
  maze.GridCoordToVerticePtr(1 , 1 , "topleft" , &V);
  V->Draw(buf , makecol(255,0,255) , v_wid);
  maze.GridCoordToVerticePtr(12 , 9 , "topright" , &V);
  V->Draw(buf , makecol(255,0,255) , v_wid);
  maze.GridCoordToVerticePtr(12 , 9 , "bottomleft" , &V);
  V->Draw(buf , makecol(255,0,255) , v_wid);
  maze.GridCoordToVerticePtr(maze.width , maze.height , "bottomright" , &V);
  V->Draw(buf , makecol(255,0,255) , v_wid);
  if (!loop_check_failure) {
    if (loop_formed) {
      maze.DrawEdge(49 , buf , makecol(0,0,255) , makecol(0,255,0) , true);
      textout_ex(buf , font , "Loop Formed" , 10 , 34 , makecol(0,255,0) , -1);
    } else {
      maze.DrawEdge(49 , buf , makecol(0,0,255) , makecol(255,0,0) , true);
      textout_ex(buf , font , "Loop Not Formed" , 10 , 34 , makecol(255,0,0) , -1);
    }
  } else {
    textout_ex(buf , font , "Loop Check Failure" , 10 , 34 , makecol(255,0,0) , -1);
  }


  
  if (maze.GridCoordToEdgePtr(1,1,"top",&KE)) {KE->SetEdgeStatus(true);}
  if (maze.GridCoordToEdgePtr(maze.width,1,"right",&KE)) {KE->SetEdgeStatus(true);}
  if (maze.GridCoordToEdgePtr(maze.width,maze.height,"bottom",&KE)) {KE->SetEdgeStatus(true);}
  if (maze.GridCoordToEdgePtr(1,maze.height,"left",&KE)) {KE->SetEdgeStatus(true);}

  
  maze.DrawAllEdges(buf , makecol(0,0,255) , makecol(0,255,0) , false);
  textout_centre_ex(buf , font , "Start with the border of the maze turned on and only one exit" , buf->w / 2 , buf->h - 34 , makecol(255,255,255) , -1);
  textout_centre_ex(buf , font , "Press space bar to continue" , buf->w / 2 , buf->h - 22 , makecol(255,255,255) , -1);
  blit(buf , screen , 0 , 0 , 0 , 0 , buf->w , buf->h);
  clear_keybuf();
  readkey();
  
  
  if (maze.KruskalizeGridEdges(log_file , buf , display_loop_checking)) {
    clear_to_color(buf , makecol(0,0,0));
    textout_centre_ex(buf , font , "Kruskal Algorithm Successfully Applied to Maze" , buf->w / 2 , 20 , makecol(0,255,0) , -1);
  } else {
    clear_to_color(buf , makecol(0,0,0));
    textout_centre_ex(buf , font , "Kruskal Algorithm Failed To Be Applied to Maze" , buf->w / 2 , 20 , makecol(255,0,0) , -1);
  }
//  maze.GridCoordToEdgePtr(maze.width , maze.height , "bottom" , &KE);
//  KE->SetEdgeStatus(false);
  
  
  Player pl(&maze , 1 , 1);
  stringstream plinfo;
  plinfo.str("");
  
  redraw = true;
  
  
  while (!(key[KEY_ESC])) {
    if (redraw) {
      clear_to_color(buf , makecol(0,0,0));
      plinfo.str("");
      plinfo << "Player info : Grid X,Y = " << pl.gx << "," << pl.gy << " Bmp X,Y = " << pl.x << "," << pl.y;
      textout_ex(buf , font , (plinfo.str()).c_str() , 20 , 20 , makecol(255,255,255) , -1);
      maze.DrawAllEdges(buf , makecol(255,255,255) , makecol(0,255,0) , false);
      //  maze.IsoMetricDrawAllEdges(ms_angle_rad , buf , makecol(255,255,255) , makecol(0,255,0) , false);
      pl.draw(buf , makecol(127,255,0));
      blit(buf , screen , 0 , 0 , 0 , 0 , buf->w , buf->h);
      redraw = false;
    }
    if (keypressed()) {
      if (pl.move()) {redraw = true;}
    }
    rest(20);
  }
    
    
  
//  clear_keybuf();
//  readkey();
  
  
  maze.DestroyGrid();
  
  return 0;
}
END_OF_MAIN()
*/



















