
#ifndef Player_H
#define Player_H

#include <allegro.h>
#include "KMaze.hpp"

class Player {
  public :
    int gx;
    int gy;
    int x;
    int y;
    int wd;
    int ht;
    int wd_pad;
    int ht_pad;
    BITMAP* pic[4];
    signed char facing;// -1 if not using a picture , 0 = up , 1 = right , 2 = down , 3 = left
    KMaze* mz;
    Player() {
      gx = gy = x = y = wd = ht = wd_pad = ht_pad = 0;
      pic[0] = pic[1] = pic[2] = pic[3] = NULL;
      facing = -1;
      mz = NULL;
    }
    
    void SetPos(int gx_pos , int gy_pos) {
      gx = gx_pos;
      gy = gy_pos;
      
      mz->XYfromGrid(gx,gy,&x,&y);
      x+=wd_pad / 2;
      y+=ht_pad / 2;
    }
    
    void SetPosAdjustment(int width_padding , int height_padding) {
      wd_pad = width_padding;
      if (wd_pad > mz->sg_width) {wd_pad = mz->sg_width;}
      if (wd_pad < 0) {wd_pad = 0;}
      
      ht_pad = height_padding;
      if (ht_pad > mz->sg_height) {ht_pad = mz->sg_height;}
      if (ht_pad < 0) {ht_pad = 0;}
      
      wd = mz->sg_width - wd_pad;
      ht = mz->sg_height - ht_pad;
    }
    
    Player(KMaze* maze , int start_gx , int start_gy , int width_padding , int height_padding) {
      mz = maze;
      
      SetPosAdjustment(width_padding , height_padding);
//      wd_pad = width_padding;
//      if (wd_pad > mz->sg_width) {wd_pad = mz->sg_width;}
//      if (wd_pad < 0) {wd_pad = 0;}
      
//      ht_pad = height_padding;
//      if (ht_pad > mz->sg_height) {ht_pad = mz->sg_height;}
//      if (ht_pad < 0) {ht_pad = 0;}
      
//      wd = mz->sg_width - wd_pad;
//      ht = mz->sg_height - ht_pad;
      
      SetPos(start_gx , start_gy);
      
//      gx = start_gx;
//      gy = start_gy;
//      mz->XYfromGrid(gx,gy,&x,&y);
//      x+=wd_pad / 2;
//      y+=ht_pad / 2;
      
      for (int i = 0 ; i < 4 ; i++) {
        pic[i] = NULL;
      }
      facing = -1;
    }
    bool set_maze(KMaze* maze , int start_gx , int start_gy , int width_padding , int height_padding) {
      if ((start_gx < 1) || (start_gx > maze->width)) {return false;}
      if ((start_gy < 1) || (start_gy > maze->height)) {return false;}
      
      mz = maze;
      
      SetPosAdjustment(width_padding , height_padding);
      
      SetPos(start_gx , start_gy);
      
//      gx = start_gx;
//      gy = start_gy;
//      mz->XYfromGrid(gx,gy,&x,&y);
//      x+=1;
//      y+=1;
      return true;
    }
    void draw(BITMAP* bmp , const int& color) {
//      rectfill(bmp , x + 2, y + 2 , x + mz->sg_width - 4 , y + mz->sg_height - 4 , color);
      rectfill(bmp , x , y , x + wd - 1 , y + ht - 1 , color);
    }
    bool move() {
  //    bool GridCoordToEdgePtr(int gx , int gy , string side , Edge** eptr_address);
      Edge* E = NULL;
      int userkey = 0;
      int gxv = 0;
      int gyv = 0;
      if (keypressed()) {
        userkey = readkey() >> 8;
        rest(50);
        clear_keybuf();
        switch (userkey) {
          case KEY_LEFT :
            if (!(mz->GridCoordToEdgePtr(gx , gy , "left" , &E))) {return false;}
            gxv = -1;
            break;
          case KEY_RIGHT :
            if (!(mz->GridCoordToEdgePtr(gx , gy , "right" , &E))) {return false;}
            gxv = 1;
            break;
          case KEY_UP :
            if (!(mz->GridCoordToEdgePtr(gx , gy , "top" , &E))) {return false;}
            gyv = -1;
            break;
          case KEY_DOWN :
            if (!(mz->GridCoordToEdgePtr(gx , gy , "bottom" , &E))) {return false;}
            gyv = 1;
            break;
          default : return false;
        }
        if (!(E->on)) {
          
          SetPos(gx + gxv , gy + gyv);
          return true;
//          gx += gxv;
//          gy += gyv;
//          mz->XYfromGrid(gx , gy , &x , &y);
//          x+=1;
//          y+=1;
        }
//        if ((gx < 1) || (gx > mz->width)) {return true;}
//        if ((gy < 1) || (gy > mz->height)) {return true;}
      }
      return false;
    }
    bool OutOfMaze() {
      if ((gx < 1) || (gx > mz->width)) {return true;}
      if ((gy < 1) || (gy > mz->height)) {return true;}
      return false;
    }
};

#endif
